package agents;

import jade.core.AID;
import jade.core.Agent;
import jade.core.behaviours.Behaviour;
import jade.core.behaviours.CyclicBehaviour;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.lang.acl.ACLMessage;
import message.messageSistem;

import java.util.ArrayList;
import java.util.ListIterator;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.Vector;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;

import behaviours.saludar;
import domain.Camarero;
import domain.Comensal;
import javax.swing.JButton;
import javax.swing.JTabbedPane;
import javax.swing.JToolBar;
import javax.swing.JLayeredPane;
import javax.swing.JDesktopPane;
import javax.swing.JInternalFrame;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Font;
import javax.swing.JTextPane;
import javax.swing.SwingConstants;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.ListSelectionModel;
import javax.swing.JScrollPane;


public class partyAgent extends Agent{

	private JFrame fpartyAGent;
	private JLabel lblinvitados, lblcamareros;
	private int satisfecho = 3; // cantidad de veces a servir para estar satisfecho
	private String textComensales,textCamareros = "";
	
	
	private Vector<Comensal> arrayComensales = new Vector<Comensal>();
	private Vector<Camarero> arrayCamareros = new Vector<Camarero>();
	private JLabel lblActivos;
	private JButton btnActivos;
	private int activos = 0;

	
	/**
	 * @wbp.parser.entryPoint
	 */
	protected void setup(){
		
		
		//DESCRIPCION DEL GRUPO
		
		DFAgentDescription agent_description = new DFAgentDescription();
		agent_description.setName(getAID());
		ServiceDescription agent_service = new ServiceDescription();
		agent_service.setName("anfitrion");
		agent_service.setType("anfitrion");
		agent_description.addServices(agent_service);
		try {
			DFService.register(this, agent_description);
		} catch (FIPAException e) {
			e.printStackTrace();
		}
		
		arrayComensales.addElement(new Comensal(this.getAID())); // Aadimos al anfitrion en el grupo de comensales
		
		// GUI

		fpartyAGent = new JFrame(this.getLocalName());
		fpartyAGent.setBounds(100, 100, 660, 453);
		fpartyAGent.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		fpartyAGent.getContentPane().setLayout(null);
		
		lblinvitados = new JLabel("");
		lblinvitados.setBounds(10, 11, 253, 339);
		fpartyAGent.getContentPane().add(lblinvitados);
		
		lblcamareros = new JLabel("");
		lblcamareros.setBounds(362, 11, 272, 282);
		fpartyAGent.getContentPane().add(lblcamareros);
		
		lblActivos = new JLabel("Invitados Activos: ");
		lblActivos.setBounds(20, 361, 124, 14);
		lblActivos.setFont(new Font("Times New Roman", Font.PLAIN, 15));
		fpartyAGent.getContentPane().add(lblActivos);
		
		btnActivos = new JButton("");
		btnActivos.setEnabled(false);
		btnActivos.setFont(new Font("Tahoma", Font.BOLD, 11));
		btnActivos.setBounds(154, 358, 52, 23);
		btnActivos.setText(Integer.toString(activos));
		fpartyAGent.getContentPane().add(btnActivos);
		
        fpartyAGent.setVisible(true);

        //BEHAVIOURS
        
		System.out.println("[ '" + this.getLocalName() + "' ::: REGISTRADO ]");
		addBehaviour(new PartyAgentCore(this));
    }
	
	protected void takeDown() {
		try {
			DFService.deregister(this);
		} catch (FIPAException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		System.out.println("\n\t\t\t --------------------------------------------------------------------- "
				 + "\n\t\t\t ---> '" + this.getLocalName() + "' ECHA A LOS CAMAREROS Y SE VA  <--- "
				 + "\n\t\t\t --------------------------------------------------------------------- "
				 + "\n\n\t ===================================================================================================");
	}

	
	
	
	public int getSatisfecho() {
		return satisfecho;
	}

	public void imprimirComensales(){
		textComensales = "<html>";
		for (Comensal comensal : arrayComensales)
			textComensales = textComensales +comensal.toString();
		lblinvitados.setText(textComensales+"</html>");		
	}
	
	public void imprimirCamareros(){
		textCamareros = "<html>";
		for (Camarero camarero : arrayCamareros)
			textCamareros = textCamareros +camarero.toString();
		lblcamareros.setText(textCamareros+"</html>");
				
	}

	public Comensal getComensal(AID aid) {
		Comensal aux = null;
		for (Comensal comensal : arrayComensales){
			if(comensal.getAid().equals(aid))
				return comensal;
		}
		return aux;
	}
	
	public Camarero getCamarero(AID aid) {
		Camarero aux = null;
		for (Camarero camarero : arrayCamareros){
			if(camarero.getAid().equals(aid))
				return camarero;
		}
		return aux;
	}

	public void setComensal(Comensal comensal) {
		arrayComensales.addElement(comensal);
	}
	
	public void setCamarero(Camarero camarero) {
		arrayCamareros.addElement(camarero);
	}
	
	public void actualizarComensal(Comensal comensal){
		
		int i = 0;
		
		while (i < arrayComensales.size()){
			if(comensal.getAid().equals(arrayComensales.get(i).getAid())){
				arrayComensales.set(i,comensal);
			}
			i++;
		}
	}
	
	public void actualizarCamarero(Camarero camarero){
		
		int i = 0;
		
		while (i < arrayCamareros.size()){
			if(camarero.getAid().equals(arrayCamareros.get(i).getAid())){
				arrayCamareros.set(i, camarero);
			}
			i++;
		}
	}
	
	public class PartyAgentCore extends CyclicBehaviour{
		
		private int todos = 10;
		private int i = 0;
				
		public PartyAgentCore(Agent a){
			super(a);
		}
		@Override
		public void action() {
			
			ACLMessage msg = myAgent.receive();
						
			Comensal comensal = null;
			Camarero camarero = null;
			
	        if (msg!= null && msg.getContent() != null)
	        {
	        	switch (msg.getContent())
	        	{
		        	case "saludar_todos": // si le saluda un invitado recien llegado
		        		
		        		System.out.println("\t'"+msg.getSender().getLocalName() + "' - SALUDA A - '" + myAgent.getLocalName()+"'\t\t\t["
		        				+msg.getSender().getLocalName()+" ---> " + myAgent.getLocalName()+"]");
	        			messageSistem.sendTo(myAgent, "saludar_uno", msg.getSender());//devuelve el saludo
	        			setComensal(new Comensal(msg.getSender()));//Aade el nuevo invitado al vector de comensales
	        			
	        			activos++;
	        			btnActivos.setText(Integer.toString(activos));				

	        			i++;
	        			if(i == todos){
	        				
		        			myAgent.doWait(3000);
	        				System.out.println("\n[ 'Camareros' ::: COMIENZAN A SERVIR	&&	'Invitados' ::: COMIENZAN A COMER ]");
	        				
	        				messageSistem.sendToGroup(myAgent, "ya", "camarero");
	        				messageSistem.sendToGroup(myAgent, "ya", "invitado");
	        			}
	        			break;
	        		 	        		
	   	        		
	        		case "servir": //si le sirven al anfitrion	
	        			
		        		System.out.println("\n\t'"+msg.getSender().getLocalName() + "' SIRVE A '" + myAgent.getLocalName()+"'\t\t["
		        				+msg.getSender().getLocalName()+" ---> " + myAgent.getLocalName()+"]");
		        		
	        			comensal = getComensal(myAgent.getAID()); //se incrementa las veces que han servido al anfitrion
	   	        		comensal.setServido();
	   	        		
	   	        		System.out.println("\t\t[ '"+myAgent.getLocalName()+"' SERVIDO: "+ comensal.getServido()+" ]");	        			

	        			actualizarComensal(comensal);
	        			comensal = null;
	        			break; 	   	        		
	   	        		
	        		case "despedirse": //se despide del invitado que se despide de el
	        			
        				comensal = getComensal(msg.getSender());
	        			
		        		System.out.println("\t\t'"+ myAgent.getLocalName() + "' DEVUELVE DESPIDO A '" + msg.getSender().getLocalName() +"'\t\t\t["+ myAgent.getLocalName() +" ---> " + msg.getSender().getLocalName() +"]"
		        						 + "\n\n\t\t'" + msg.getSender().getLocalName() + "' VECES SERVIDO >>> \"" + comensal.getServido() +"\"");
	        			messageSistem.sendTo(myAgent, "ok", msg.getSender()); // el anfitrion le devuelve el saludo de despedida para que se pueda marchar
	        			
	        			activos--;
	        			btnActivos.setText(Integer.toString(activos));
	        			
	        			if(activos == 0){
	        				comensal = getComensal(myAgent.getAID());
	        				comensal.setSatisfecho(true);
	        				actualizarComensal(comensal);
	        				comensal = null;
	        				
							messageSistem.sendToGroup(myAgent, "terminar", "camarero");
	        				
							myAgent.doDelete();
	        			}
	   	        		break; 
	   	        	
	        		case "me_han_servido": //Controla las veces que sirven a cada invitado
	        			
	        			comensal = getComensal(msg.getSender());// se incrementa el numero de veces que le han servido al invitado x
	        			
	        			if(comensal.getServido() < 3 || comensal.getAid().getLocalName().equals("Anfitrion")){
	        				
	        				comensal.setServido();
	        				
		   	        		System.out.println("\t\t[ '"+ msg.getSender().getLocalName() +"' SERVIDO: "+ comensal.getServido()+" ]");	        			
	        			}
	        			
	        			if (comensal.getServido() == getSatisfecho()){ // si se le ha servido tantas veces como la variable satisfecho, esta satisfecho
	        				comensal.setSatisfecho(true);
	        				messageSistem.sendTo(myAgent, "satisfecho", msg.getSender()); // indica al invitado que esta satisfecho, que esta satisfecho [esta redundancia es para poder llevar un control en el vector]
	        			}
	        			
        				actualizarComensal(comensal);
	        			comensal = null;
	        			
	   	        		break;	   	        		
	   	        		
	        		case "ha_servido": //controla las veces que sirve cada camarero
	        				        			
	        			if (getCamarero(msg.getSender()) == null)// si el camarero que ha servido es un nuevo camarero que no esta registrado en el vector...
	        				setCamarero(new Camarero(msg.getSender()));//se almacena en el vector
	        			camarero = getCamarero(msg.getSender()); //le incrementa las veces que ha servido
	   	        		camarero.setServir();
	   	        		
	   	        		System.out.println("\t\t[ '"+ msg.getSender().getLocalName() +"' SIRVE:   "+ camarero.getServir()+" ]");	        			

	        			actualizarCamarero(camarero);
	        			camarero = null;
	        			
	        			break; 
	   	        		
	        	}
	        	
    			imprimirComensales(); //imprimimos el vector de comensales
    			imprimirCamareros(); //imprimimos el vector de camareros

    			//imprimirComensalesTabla();
    			
	        }
	       
		}
		
	}
}
