package behaviours;


import java.util.Random;

import domain.Comensal;
import jade.core.Agent;
import jade.core.behaviours.Behaviour;
import jade.core.behaviours.CyclicBehaviour;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.lang.acl.ACLMessage;
import message.messageSistem;

public class comer extends CyclicBehaviour{

	private saludar saluda;
	
	public comer(Agent a, saludar behaviour){
		super(a);
		saluda = behaviour;
	}
	
	public void onStart(){
		
		//Se elimina el behaviour 'salidar' para que no haya problemas,
		//	al estar ejecutandose ese cyclic por detras.
		myAgent.removeBehaviour(saluda);
	}
	
	public void action() {
		
		
		ACLMessage msg = myAgent.receive();
		Comensal comensal = new Comensal(myAgent.getAID());
		
		if (msg!= null && msg.getContent() != null )
        {

	        	switch (msg.getContent())
	        	{  		
	        		case "servir": // un camarero le ha servido
	        			
		        		System.out.println("\n\t'"+msg.getSender().getLocalName() + "' SIRVE A '" + myAgent.getLocalName()+"'\t\t["
		        				+msg.getSender().getLocalName()+" ---> " + myAgent.getLocalName()+"]");
	        			
        				messageSistem.sendToGroup(myAgent, "me_han_servido", "anfitrion"); //permitira indicar a que invitado le han servido
	        			break;
	        			
	        		case "satisfecho":
		        		System.out.println("\n\t ==================================================================================================="
		        						 + "\n\n\t\t'"+ myAgent.getLocalName() + "' SATISFECHO, SE DESPIDE DE '" + msg.getSender().getLocalName()+"'\t\t[" + myAgent.getLocalName() +" ---> " + msg.getSender().getLocalName() +"]");
		        		
	        			messageSistem.sendToGroup(myAgent, "despedirse", "anfitrion");
	        			break;
	        			
					case "ok": // el anfitrion le ha devuelto la despedida y se marcha de la fiesta
						myAgent.doDelete();
						break;
	        	}
	        	
        }
	}	

}
