package message;

import java.util.Random;
import java.util.Vector;

import domain.Comensal;
import jade.core.AID;
import jade.core.Agent;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.lang.acl.ACLMessage;


public class messageSistem extends Agent {

	public static Random rand = new Random();
	
	public static int random(int max) {
		return rand.nextInt(max);
	}
	

	public static boolean sendToGroup(Agent sender, String content, String group) { //ENVIA MSG A UN GRUPO DADO
			
		DFAgentDescription template = new DFAgentDescription();
		ServiceDescription sd = new ServiceDescription();
		sd.setType(group);
		template.addServices(sd);
		
		try {
			DFAgentDescription[] humans = DFService.search(sender, template);
			for (DFAgentDescription human: humans) {
				ACLMessage reply = new ACLMessage(ACLMessage.INFORM);
				if (!human.getName().equals(sender.getName())) // evitamos que lo reciva el mismo agente que lo envie
					reply.addReceiver(human.getName());
				reply.setContent(content);
				sender.send(reply);
			}
		} catch (FIPAException e1) {
			e1.printStackTrace();
			return false;
		}
		return true;
	}


	public static boolean sendToGroup_Random(Agent sender, String content, String objetivo) { //ENVIA MSG A UN AGENTE RANDOM DE UN GRUPO DADO
	
		DFAgentDescription template = new DFAgentDescription();
		ServiceDescription sd = new ServiceDescription();
		sd.setType(objetivo);
		template.addServices(sd);
		
		try {
			DFAgentDescription[] aFinder = DFService.search(sender, template);
			if (aFinder.length == 0) return false;
			int rand = random(aFinder.length);
			//System.out.println("              Random:   " + rand);
			DFAgentDescription reciver = aFinder[rand];
			//System.out.println("\t------ Grupo: " + objetivo+ "\t Nombre agente: " + reciver.getName().getLocalName() + "\tContenido msg: " + content);
			ACLMessage reply = new ACLMessage(ACLMessage.INFORM);
			reply.addReceiver(reciver.getName());
			reply.setContent(content);
			sender.send(reply);
			
		} catch (FIPAException e1) {
			e1.printStackTrace();
			return false;
		}
		return true;
	}
	
	public static boolean sendTo(Agent sender, String content, AID reciver) { //ENVIA MSG A UN AGENTE DADO
		
		try {
			ACLMessage reply = new ACLMessage(1);
			reply.addReceiver(reciver);
			reply.setPerformative(ACLMessage.INFORM);
			reply.setContent(content);
		
			sender.send(reply);
			
		} catch (Exception e1) {
			e1.printStackTrace();
			return false;
		}
		return true;
	}
	
}
